/* archive-reader.c generated by valac 0.28.0, the Vala compiler
 * generated from archive-reader.vala, do not modify */

/* This file is part of GNOME Boxes. License: LGPLv2+*/

#include <glib.h>
#include <glib-object.h>
#include <archive.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <archive_entry.h>
#include <libcommon.h>
#include <stdio.h>
#include <glib/gstdio.h>


#define BOXES_TYPE_ARCHIVE_READER (boxes_archive_reader_get_type ())
#define BOXES_ARCHIVE_READER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BOXES_TYPE_ARCHIVE_READER, BoxesArchiveReader))
#define BOXES_ARCHIVE_READER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), BOXES_TYPE_ARCHIVE_READER, BoxesArchiveReaderClass))
#define BOXES_IS_ARCHIVE_READER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BOXES_TYPE_ARCHIVE_READER))
#define BOXES_IS_ARCHIVE_READER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), BOXES_TYPE_ARCHIVE_READER))
#define BOXES_ARCHIVE_READER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), BOXES_TYPE_ARCHIVE_READER, BoxesArchiveReaderClass))

typedef struct _BoxesArchiveReader BoxesArchiveReader;
typedef struct _BoxesArchiveReaderClass BoxesArchiveReaderClass;
typedef struct _BoxesArchiveReaderPrivate BoxesArchiveReaderPrivate;
#define _archive_read_finish0(var) ((var == NULL) ? NULL : (var = (archive_read_finish (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_list_free0(var) ((var == NULL) ? NULL : (var = (g_list_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define __g_list_free__g_free0_0(var) ((var == NULL) ? NULL : (var = (_g_list_free__g_free0_ (var), NULL)))
typedef struct _Block10Data Block10Data;
#define _fclose0(var) ((var == NULL) ? NULL : (var = (fclose (var), NULL)))
typedef struct _Block11Data Block11Data;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _BoxesArchiveReader {
	GObject parent_instance;
	BoxesArchiveReaderPrivate * priv;
	struct archive* archive;
};

struct _BoxesArchiveReaderClass {
	GObjectClass parent_class;
};

struct _BoxesArchiveReaderPrivate {
	gchar* filename;
	int* format;
	GList* filters;
};

struct _Block10Data {
	int _ref_count_;
	BoxesArchiveReader* self;
	FILE* fd;
};

struct _Block11Data {
	int _ref_count_;
	BoxesArchiveReader* self;
	int filter;
};


static gpointer boxes_archive_reader_parent_class = NULL;

GType boxes_archive_reader_get_type (void) G_GNUC_CONST;
#define BOXES_ARCHIVE_READER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), BOXES_TYPE_ARCHIVE_READER, BoxesArchiveReaderPrivate))
enum  {
	BOXES_ARCHIVE_READER_DUMMY_PROPERTY
};
#define BOXES_ARCHIVE_READER_BLOCK_SIZE 10240
BoxesArchiveReader* boxes_archive_reader_new (const gchar* filename, int* format, GList* filters, GError** error);
BoxesArchiveReader* boxes_archive_reader_construct (GType object_type, const gchar* filename, int* format, GList* filters, GError** error);
static int* _archive_format_dup (int* self);
static void boxes_archive_reader_open_archive (BoxesArchiveReader* self, GError** error);
GList* boxes_archive_reader_get_file_list (BoxesArchiveReader* self, GError** error);
static void _g_free0_ (gpointer var);
static void _g_list_free__g_free0_ (GList* self);
void boxes_archive_reader_extract_file (BoxesArchiveReader* self, const gchar* src, const gchar* dest, gboolean override_if_necessary, GError** error);
static void boxes_archive_reader_extract_files_recursive (BoxesArchiveReader* self, gchar** src_list, int src_list_length1, gchar** dest_list, int dest_list_length1, gboolean override_if_necessary, gboolean follow_hardlinks, GError** error);
void boxes_archive_reader_reset (BoxesArchiveReader* self, GError** error);
static int _archive_read_close_boxes_libarchive_function (gpointer self);
static Block10Data* block10_data_ref (Block10Data* _data10_);
static void block10_data_unref (void * _userdata_);
static gchar* boxes_archive_reader_get_dest_file (BoxesArchiveReader* self, gchar** src_list, int src_list_length1, gchar** dest_list, int dest_list_length1, const gchar* src);
static int _archive_read_data_skip_boxes_libarchive_function (gpointer self);
static void _vala_array_add1 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add2 (gchar*** array, int* length, int* size, gchar* value);
static int ___lambda90_ (Block10Data* _data10_);
static int ____lambda90__boxes_libarchive_function (gpointer self);
static int _archive_read_support_format_all_boxes_libarchive_function (gpointer self);
static int ___lambda87_ (BoxesArchiveReader* self);
static int ____lambda87__boxes_libarchive_function (gpointer self);
static int _archive_read_support_filter_all_boxes_libarchive_function (gpointer self);
static Block11Data* block11_data_ref (Block11Data* _data11_);
static void block11_data_unref (void * _userdata_);
static int _____lambda88_ (Block11Data* _data11_);
static int ______lambda88__boxes_libarchive_function (gpointer self);
static int __lambda89_ (BoxesArchiveReader* self);
static int ___lambda89__boxes_libarchive_function (gpointer self);
static void boxes_archive_reader_finalize (GObject* obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);


static int* _archive_format_dup (int* self) {
	int* dup;
	dup = g_new0 (int, 1);
	memcpy (dup, self, sizeof (int));
	return dup;
}


static gpointer __archive_format_dup0 (gpointer self) {
	return self ? _archive_format_dup (self) : NULL;
}


BoxesArchiveReader* boxes_archive_reader_construct (GType object_type, const gchar* filename, int* format, GList* filters, GError** error) {
	BoxesArchiveReader * self = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	int* _tmp2_ = NULL;
	int* _tmp3_ = NULL;
	GList* _tmp4_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (filename != NULL, NULL);
	self = (BoxesArchiveReader*) g_object_new (object_type, NULL);
	_tmp0_ = filename;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->filename);
	self->priv->filename = _tmp1_;
	_tmp2_ = format;
	_tmp3_ = __archive_format_dup0 (_tmp2_);
	_g_free0 (self->priv->format);
	self->priv->format = _tmp3_;
	_tmp4_ = filters;
	if (_tmp4_ != NULL) {
		GList* _tmp5_ = NULL;
		GList* _tmp6_ = NULL;
		_tmp5_ = filters;
		_tmp6_ = g_list_copy (_tmp5_);
		_g_list_free0 (self->priv->filters);
		self->priv->filters = _tmp6_;
	}
	boxes_archive_reader_open_archive (self, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == G_IO_ERROR) {
			g_propagate_error (error, _inner_error_);
			_g_object_unref0 (self);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	return self;
}


BoxesArchiveReader* boxes_archive_reader_new (const gchar* filename, int* format, GList* filters, GError** error) {
	return boxes_archive_reader_construct (BOXES_TYPE_ARCHIVE_READER, filename, format, filters, error);
}


static void _g_free0_ (gpointer var) {
	var = (g_free (var), NULL);
}


static void _g_list_free__g_free0_ (GList* self) {
	g_list_foreach (self, (GFunc) _g_free0_, NULL);
	g_list_free (self);
}


GList* boxes_archive_reader_get_file_list (BoxesArchiveReader* self, GError** error) {
	GList* result = NULL;
	GList* _result_ = NULL;
	struct archive_entry* iterator = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_result_ = NULL;
	while (TRUE) {
		gboolean _tmp0_ = FALSE;
		struct archive* _tmp1_ = NULL;
		struct archive_entry* _tmp2_ = NULL;
		gboolean _tmp3_ = FALSE;
		struct archive_entry* _tmp4_ = NULL;
		const gchar* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
		_tmp1_ = self->archive;
		_tmp3_ = boxes_get_next_header (_tmp1_, &_tmp2_, (guint) 1, &_inner_error_);
		iterator = _tmp2_;
		_tmp0_ = _tmp3_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_IO_ERROR) {
				g_propagate_error (error, _inner_error_);
				__g_list_free__g_free0_0 (_result_);
				return NULL;
			} else {
				__g_list_free__g_free0_0 (_result_);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return NULL;
			}
		}
		if (!_tmp0_) {
			break;
		}
		_tmp4_ = iterator;
		_tmp5_ = archive_entry_pathname (_tmp4_);
		_tmp6_ = g_strdup (_tmp5_);
		_result_ = g_list_append (_result_, _tmp6_);
	}
	result = _result_;
	return result;
}


void boxes_archive_reader_extract_file (BoxesArchiveReader* self, const gchar* src, const gchar* dest, gboolean override_if_necessary, GError** error) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar** _tmp2_ = NULL;
	gchar** _tmp3_ = NULL;
	gint _tmp3__length1 = 0;
	const gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	gchar** _tmp6_ = NULL;
	gchar** _tmp7_ = NULL;
	gint _tmp7__length1 = 0;
	gboolean _tmp8_ = FALSE;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (src != NULL);
	g_return_if_fail (dest != NULL);
	_tmp0_ = src;
	_tmp1_ = g_strdup (_tmp0_);
	_tmp2_ = g_new0 (gchar*, 1 + 1);
	_tmp2_[0] = _tmp1_;
	_tmp3_ = _tmp2_;
	_tmp3__length1 = 1;
	_tmp4_ = dest;
	_tmp5_ = g_strdup (_tmp4_);
	_tmp6_ = g_new0 (gchar*, 1 + 1);
	_tmp6_[0] = _tmp5_;
	_tmp7_ = _tmp6_;
	_tmp7__length1 = 1;
	_tmp8_ = override_if_necessary;
	boxes_archive_reader_extract_files_recursive (self, _tmp3_, 1, _tmp7_, 1, _tmp8_, TRUE, &_inner_error_);
	_tmp7_ = (_vala_array_free (_tmp7_, _tmp7__length1, (GDestroyNotify) g_free), NULL);
	_tmp3_ = (_vala_array_free (_tmp3_, _tmp3__length1, (GDestroyNotify) g_free), NULL);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == G_IO_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


static int _archive_read_close_boxes_libarchive_function (gpointer self) {
	int result;
	result = archive_read_close ((struct archive*) self);
	return result;
}


void boxes_archive_reader_reset (BoxesArchiveReader* self, GError** error) {
	struct archive* _tmp0_ = NULL;
	struct archive* _tmp1_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->archive;
	_tmp1_ = self->archive;
	boxes_execute_libarchive_function (_tmp0_, _archive_read_close_boxes_libarchive_function, _tmp1_, (guint) 1, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == G_IO_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	boxes_archive_reader_open_archive (self, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == G_IO_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


static Block10Data* block10_data_ref (Block10Data* _data10_) {
	g_atomic_int_inc (&_data10_->_ref_count_);
	return _data10_;
}


static void block10_data_unref (void * _userdata_) {
	Block10Data* _data10_;
	_data10_ = (Block10Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data10_->_ref_count_)) {
		BoxesArchiveReader* self;
		self = _data10_->self;
		_fclose0 (_data10_->fd);
		_g_object_unref0 (self);
		g_slice_free (Block10Data, _data10_);
	}
}


static int _archive_read_data_skip_boxes_libarchive_function (gpointer self) {
	int result;
	result = archive_read_data_skip ((struct archive*) self);
	return result;
}


static void _vala_array_add1 (gchar*** array, int* length, int* size, gchar* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static void _vala_array_add2 (gchar*** array, int* length, int* size, gchar* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static int ___lambda90_ (Block10Data* _data10_) {
	BoxesArchiveReader* self;
	int result = 0;
	struct archive* _tmp0_ = NULL;
	FILE* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	int _tmp3_ = 0;
	self = _data10_->self;
	_tmp0_ = self->archive;
	_tmp1_ = _data10_->fd;
	_tmp2_ = fileno (_tmp1_);
	_tmp3_ = archive_read_data_into_fd (_tmp0_, _tmp2_);
	result = _tmp3_;
	return result;
}


static int ____lambda90__boxes_libarchive_function (gpointer self) {
	int result;
	result = ___lambda90_ (self);
	return result;
}


static void boxes_archive_reader_extract_files_recursive (BoxesArchiveReader* self, gchar** src_list, int src_list_length1, gchar** dest_list, int dest_list_length1, gboolean override_if_necessary, gboolean follow_hardlinks, GError** error) {
	gchar** _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	gchar** _tmp1_ = NULL;
	gint _tmp1__length1 = 0;
	gchar** _tmp2_ = NULL;
	gint _tmp2__length1 = 0;
	struct archive_entry* iterator = NULL;
	guint i = 0U;
	gchar** hardlink_src = NULL;
	gchar** _tmp3_ = NULL;
	gint hardlink_src_length1 = 0;
	gint _hardlink_src_size_ = 0;
	gchar** hardlink_dest = NULL;
	gchar** _tmp4_ = NULL;
	gint hardlink_dest_length1 = 0;
	gint _hardlink_dest_size_ = 0;
	gchar** _tmp49_ = NULL;
	gint _tmp49__length1 = 0;
	guint _tmp50_ = 0U;
	gchar** _tmp52_ = NULL;
	gint _tmp52__length1 = 0;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = src_list;
	_tmp0__length1 = src_list_length1;
	_tmp1_ = dest_list;
	_tmp1__length1 = dest_list_length1;
	_vala_return_if_fail (_tmp0__length1 == _tmp1__length1, "src_list.length == dest_list.length");
	_tmp2_ = src_list;
	_tmp2__length1 = src_list_length1;
	if (_tmp2__length1 == 0) {
		return;
	}
	i = (guint) 0;
	_tmp3_ = g_new0 (gchar*, 0 + 1);
	hardlink_src = _tmp3_;
	hardlink_src_length1 = 0;
	_hardlink_src_size_ = hardlink_src_length1;
	_tmp4_ = g_new0 (gchar*, 0 + 1);
	hardlink_dest = _tmp4_;
	hardlink_dest_length1 = 0;
	_hardlink_dest_size_ = hardlink_dest_length1;
	while (TRUE) {
		Block10Data* _data10_;
		gboolean _tmp5_ = FALSE;
		gboolean _tmp6_ = FALSE;
		struct archive* _tmp7_ = NULL;
		struct archive_entry* _tmp8_ = NULL;
		gboolean _tmp9_ = FALSE;
		gchar* dest = NULL;
		gchar** _tmp12_ = NULL;
		gint _tmp12__length1 = 0;
		gchar** _tmp13_ = NULL;
		gint _tmp13__length1 = 0;
		struct archive_entry* _tmp14_ = NULL;
		const gchar* _tmp15_ = NULL;
		gchar* _tmp16_ = NULL;
		const gchar* _tmp17_ = NULL;
		gboolean _tmp20_ = FALSE;
		struct archive_entry* _tmp21_ = NULL;
		const gchar* _tmp22_ = NULL;
		gboolean _tmp37_ = FALSE;
		gboolean _tmp38_ = FALSE;
		const gchar* _tmp43_ = NULL;
		FILE* _tmp44_ = NULL;
		struct archive* _tmp45_ = NULL;
		const gchar* _tmp46_ = NULL;
		const gchar* _tmp47_ = NULL;
		guint _tmp48_ = 0U;
		_data10_ = g_slice_new0 (Block10Data);
		_data10_->_ref_count_ = 1;
		_data10_->self = g_object_ref (self);
		_tmp7_ = self->archive;
		_tmp9_ = boxes_get_next_header (_tmp7_, &_tmp8_, (guint) 1, &_inner_error_);
		iterator = _tmp8_;
		_tmp6_ = _tmp9_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_IO_ERROR) {
				g_propagate_error (error, _inner_error_);
				block10_data_unref (_data10_);
				_data10_ = NULL;
				hardlink_dest = (_vala_array_free (hardlink_dest, hardlink_dest_length1, (GDestroyNotify) g_free), NULL);
				hardlink_src = (_vala_array_free (hardlink_src, hardlink_src_length1, (GDestroyNotify) g_free), NULL);
				return;
			} else {
				block10_data_unref (_data10_);
				_data10_ = NULL;
				hardlink_dest = (_vala_array_free (hardlink_dest, hardlink_dest_length1, (GDestroyNotify) g_free), NULL);
				hardlink_src = (_vala_array_free (hardlink_src, hardlink_src_length1, (GDestroyNotify) g_free), NULL);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		}
		if (_tmp6_) {
			guint _tmp10_ = 0U;
			gchar** _tmp11_ = NULL;
			gint _tmp11__length1 = 0;
			_tmp10_ = i;
			_tmp11_ = src_list;
			_tmp11__length1 = src_list_length1;
			_tmp5_ = _tmp10_ < ((guint) _tmp11__length1);
		} else {
			_tmp5_ = FALSE;
		}
		if (!_tmp5_) {
			block10_data_unref (_data10_);
			_data10_ = NULL;
			break;
		}
		_tmp12_ = src_list;
		_tmp12__length1 = src_list_length1;
		_tmp13_ = dest_list;
		_tmp13__length1 = dest_list_length1;
		_tmp14_ = iterator;
		_tmp15_ = archive_entry_pathname (_tmp14_);
		_tmp16_ = boxes_archive_reader_get_dest_file (self, _tmp12_, _tmp12__length1, _tmp13_, _tmp13__length1, _tmp15_);
		dest = _tmp16_;
		_tmp17_ = dest;
		if (_tmp17_ == NULL) {
			struct archive* _tmp18_ = NULL;
			struct archive* _tmp19_ = NULL;
			_tmp18_ = self->archive;
			_tmp19_ = self->archive;
			boxes_execute_libarchive_function (_tmp18_, _archive_read_data_skip_boxes_libarchive_function, _tmp19_, (guint) 1, &_inner_error_);
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				if (_inner_error_->domain == G_IO_ERROR) {
					g_propagate_error (error, _inner_error_);
					_g_free0 (dest);
					block10_data_unref (_data10_);
					_data10_ = NULL;
					hardlink_dest = (_vala_array_free (hardlink_dest, hardlink_dest_length1, (GDestroyNotify) g_free), NULL);
					hardlink_src = (_vala_array_free (hardlink_src, hardlink_src_length1, (GDestroyNotify) g_free), NULL);
					return;
				} else {
					_g_free0 (dest);
					block10_data_unref (_data10_);
					_data10_ = NULL;
					hardlink_dest = (_vala_array_free (hardlink_dest, hardlink_dest_length1, (GDestroyNotify) g_free), NULL);
					hardlink_src = (_vala_array_free (hardlink_src, hardlink_src_length1, (GDestroyNotify) g_free), NULL);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
					return;
				}
			}
			_g_free0 (dest);
			block10_data_unref (_data10_);
			_data10_ = NULL;
			continue;
		}
		_tmp21_ = iterator;
		_tmp22_ = archive_entry_hardlink (_tmp21_);
		if (_tmp22_ != NULL) {
			struct archive_entry* _tmp23_ = NULL;
			gint64 _tmp24_ = 0LL;
			_tmp23_ = iterator;
			_tmp24_ = archive_entry_size (_tmp23_);
			_tmp20_ = _tmp24_ == ((gint64) 0);
		} else {
			_tmp20_ = FALSE;
		}
		if (_tmp20_) {
			struct archive_entry* _tmp25_ = NULL;
			const gchar* _tmp26_ = NULL;
			struct archive_entry* _tmp27_ = NULL;
			const gchar* _tmp28_ = NULL;
			gchar** _tmp29_ = NULL;
			gint _tmp29__length1 = 0;
			struct archive_entry* _tmp30_ = NULL;
			const gchar* _tmp31_ = NULL;
			gchar* _tmp32_ = NULL;
			gchar** _tmp33_ = NULL;
			gint _tmp33__length1 = 0;
			const gchar* _tmp34_ = NULL;
			gchar* _tmp35_ = NULL;
			guint _tmp36_ = 0U;
			_tmp25_ = iterator;
			_tmp26_ = archive_entry_pathname (_tmp25_);
			_tmp27_ = iterator;
			_tmp28_ = archive_entry_hardlink (_tmp27_);
			g_debug ("archive-reader.vala:72: Following hardlink of '%s' to '%s'.", _tmp26_, _tmp28_);
			_tmp29_ = hardlink_src;
			_tmp29__length1 = hardlink_src_length1;
			_tmp30_ = iterator;
			_tmp31_ = archive_entry_hardlink (_tmp30_);
			_tmp32_ = g_strdup (_tmp31_);
			_vala_array_add1 (&hardlink_src, &hardlink_src_length1, &_hardlink_src_size_, _tmp32_);
			_tmp33_ = hardlink_dest;
			_tmp33__length1 = hardlink_dest_length1;
			_tmp34_ = dest;
			_tmp35_ = g_strdup (_tmp34_);
			_vala_array_add2 (&hardlink_dest, &hardlink_dest_length1, &_hardlink_dest_size_, _tmp35_);
			_tmp36_ = i;
			i = _tmp36_ + 1;
			_g_free0 (dest);
			block10_data_unref (_data10_);
			_data10_ = NULL;
			continue;
		}
		_tmp38_ = override_if_necessary;
		if (!_tmp38_) {
			const gchar* _tmp39_ = NULL;
			gboolean _tmp40_ = FALSE;
			_tmp39_ = dest;
			_tmp40_ = g_file_test (_tmp39_, G_FILE_TEST_EXISTS);
			_tmp37_ = _tmp40_;
		} else {
			_tmp37_ = FALSE;
		}
		if (_tmp37_) {
			const gchar* _tmp41_ = NULL;
			GError* _tmp42_ = NULL;
			_tmp41_ = dest;
			_tmp42_ = g_error_new (G_IO_ERROR, G_IO_ERROR_EXISTS, "Destination file '%s' already exists.", _tmp41_);
			_inner_error_ = _tmp42_;
			if (_inner_error_->domain == G_IO_ERROR) {
				g_propagate_error (error, _inner_error_);
				_g_free0 (dest);
				block10_data_unref (_data10_);
				_data10_ = NULL;
				hardlink_dest = (_vala_array_free (hardlink_dest, hardlink_dest_length1, (GDestroyNotify) g_free), NULL);
				hardlink_src = (_vala_array_free (hardlink_src, hardlink_src_length1, (GDestroyNotify) g_free), NULL);
				return;
			} else {
				_g_free0 (dest);
				block10_data_unref (_data10_);
				_data10_ = NULL;
				hardlink_dest = (_vala_array_free (hardlink_dest, hardlink_dest_length1, (GDestroyNotify) g_free), NULL);
				hardlink_src = (_vala_array_free (hardlink_src, hardlink_src_length1, (GDestroyNotify) g_free), NULL);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		}
		_tmp43_ = dest;
		_tmp44_ = g_fopen (_tmp43_, "w+");
		_data10_->fd = _tmp44_;
		_tmp45_ = self->archive;
		boxes_execute_libarchive_function (_tmp45_, ____lambda90__boxes_libarchive_function, _data10_, (guint) 1, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_IO_ERROR) {
				g_propagate_error (error, _inner_error_);
				_g_free0 (dest);
				block10_data_unref (_data10_);
				_data10_ = NULL;
				hardlink_dest = (_vala_array_free (hardlink_dest, hardlink_dest_length1, (GDestroyNotify) g_free), NULL);
				hardlink_src = (_vala_array_free (hardlink_src, hardlink_src_length1, (GDestroyNotify) g_free), NULL);
				return;
			} else {
				_g_free0 (dest);
				block10_data_unref (_data10_);
				_data10_ = NULL;
				hardlink_dest = (_vala_array_free (hardlink_dest, hardlink_dest_length1, (GDestroyNotify) g_free), NULL);
				hardlink_src = (_vala_array_free (hardlink_src, hardlink_src_length1, (GDestroyNotify) g_free), NULL);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		}
		_tmp46_ = dest;
		_tmp47_ = self->priv->filename;
		g_debug ("archive-reader.vala:87: Extracted file '%s' from archive '%s'.", _tmp46_, _tmp47_);
		_tmp48_ = i;
		i = _tmp48_ + 1;
		_g_free0 (dest);
		block10_data_unref (_data10_);
		_data10_ = NULL;
	}
	_tmp49_ = src_list;
	_tmp49__length1 = src_list_length1;
	_tmp50_ = i;
	if (((guint) _tmp49__length1) != _tmp50_) {
		GError* _tmp51_ = NULL;
		_tmp51_ = g_error_new_literal (G_IO_ERROR, G_IO_ERROR_NOT_FOUND, "At least one specified file was not found in the archive.");
		_inner_error_ = _tmp51_;
		if (_inner_error_->domain == G_IO_ERROR) {
			g_propagate_error (error, _inner_error_);
			hardlink_dest = (_vala_array_free (hardlink_dest, hardlink_dest_length1, (GDestroyNotify) g_free), NULL);
			hardlink_src = (_vala_array_free (hardlink_src, hardlink_src_length1, (GDestroyNotify) g_free), NULL);
			return;
		} else {
			hardlink_dest = (_vala_array_free (hardlink_dest, hardlink_dest_length1, (GDestroyNotify) g_free), NULL);
			hardlink_src = (_vala_array_free (hardlink_src, hardlink_src_length1, (GDestroyNotify) g_free), NULL);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	boxes_archive_reader_reset (self, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == G_IO_ERROR) {
			g_propagate_error (error, _inner_error_);
			hardlink_dest = (_vala_array_free (hardlink_dest, hardlink_dest_length1, (GDestroyNotify) g_free), NULL);
			hardlink_src = (_vala_array_free (hardlink_src, hardlink_src_length1, (GDestroyNotify) g_free), NULL);
			return;
		} else {
			hardlink_dest = (_vala_array_free (hardlink_dest, hardlink_dest_length1, (GDestroyNotify) g_free), NULL);
			hardlink_src = (_vala_array_free (hardlink_src, hardlink_src_length1, (GDestroyNotify) g_free), NULL);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_tmp52_ = hardlink_src;
	_tmp52__length1 = hardlink_src_length1;
	if (_tmp52__length1 > 0) {
		gboolean _tmp53_ = FALSE;
		_tmp53_ = follow_hardlinks;
		if (_tmp53_) {
			gchar** _tmp54_ = NULL;
			gint _tmp54__length1 = 0;
			gchar** _tmp55_ = NULL;
			gint _tmp55__length1 = 0;
			gboolean _tmp56_ = FALSE;
			_tmp54_ = hardlink_src;
			_tmp54__length1 = hardlink_src_length1;
			_tmp55_ = hardlink_dest;
			_tmp55__length1 = hardlink_dest_length1;
			_tmp56_ = override_if_necessary;
			boxes_archive_reader_extract_files_recursive (self, _tmp54_, _tmp54__length1, _tmp55_, _tmp55__length1, _tmp56_, FALSE, &_inner_error_);
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				if (_inner_error_->domain == G_IO_ERROR) {
					g_propagate_error (error, _inner_error_);
					hardlink_dest = (_vala_array_free (hardlink_dest, hardlink_dest_length1, (GDestroyNotify) g_free), NULL);
					hardlink_src = (_vala_array_free (hardlink_src, hardlink_src_length1, (GDestroyNotify) g_free), NULL);
					return;
				} else {
					hardlink_dest = (_vala_array_free (hardlink_dest, hardlink_dest_length1, (GDestroyNotify) g_free), NULL);
					hardlink_src = (_vala_array_free (hardlink_src, hardlink_src_length1, (GDestroyNotify) g_free), NULL);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
					return;
				}
			}
		} else {
			gchar* msg = NULL;
			gchar* _tmp57_ = NULL;
			const gchar* _tmp58_ = NULL;
			GError* _tmp59_ = NULL;
			_tmp57_ = g_strdup ("Maximum recursion depth exceeded. It is likely that a hardlink points " \
"to itself.");
			msg = _tmp57_;
			_tmp58_ = msg;
			_tmp59_ = g_error_new_literal (G_IO_ERROR, G_IO_ERROR_WOULD_RECURSE, _tmp58_);
			_inner_error_ = _tmp59_;
			if (_inner_error_->domain == G_IO_ERROR) {
				g_propagate_error (error, _inner_error_);
				_g_free0 (msg);
				hardlink_dest = (_vala_array_free (hardlink_dest, hardlink_dest_length1, (GDestroyNotify) g_free), NULL);
				hardlink_src = (_vala_array_free (hardlink_src, hardlink_src_length1, (GDestroyNotify) g_free), NULL);
				return;
			} else {
				_g_free0 (msg);
				hardlink_dest = (_vala_array_free (hardlink_dest, hardlink_dest_length1, (GDestroyNotify) g_free), NULL);
				hardlink_src = (_vala_array_free (hardlink_src, hardlink_src_length1, (GDestroyNotify) g_free), NULL);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
			_g_free0 (msg);
		}
	}
	hardlink_dest = (_vala_array_free (hardlink_dest, hardlink_dest_length1, (GDestroyNotify) g_free), NULL);
	hardlink_src = (_vala_array_free (hardlink_src, hardlink_src_length1, (GDestroyNotify) g_free), NULL);
}


static gchar* boxes_archive_reader_get_dest_file (BoxesArchiveReader* self, gchar** src_list, int src_list_length1, gchar** dest_list, int dest_list_length1, const gchar* src) {
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (src != NULL, NULL);
	{
		guint j = 0U;
		j = (guint) 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				guint _tmp2_ = 0U;
				gchar** _tmp3_ = NULL;
				gint _tmp3__length1 = 0;
				gchar** _tmp4_ = NULL;
				gint _tmp4__length1 = 0;
				guint _tmp5_ = 0U;
				const gchar* _tmp6_ = NULL;
				const gchar* _tmp7_ = NULL;
				if (!_tmp0_) {
					guint _tmp1_ = 0U;
					_tmp1_ = j;
					j = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = j;
				_tmp3_ = src_list;
				_tmp3__length1 = src_list_length1;
				if (!(_tmp2_ < ((guint) _tmp3__length1))) {
					break;
				}
				_tmp4_ = src_list;
				_tmp4__length1 = src_list_length1;
				_tmp5_ = j;
				_tmp6_ = _tmp4_[_tmp5_];
				_tmp7_ = src;
				if (g_strcmp0 (_tmp6_, _tmp7_) == 0) {
					gchar** _tmp8_ = NULL;
					gint _tmp8__length1 = 0;
					guint _tmp9_ = 0U;
					const gchar* _tmp10_ = NULL;
					gchar* _tmp11_ = NULL;
					_tmp8_ = dest_list;
					_tmp8__length1 = dest_list_length1;
					_tmp9_ = j;
					_tmp10_ = _tmp8_[_tmp9_];
					_tmp11_ = g_strdup (_tmp10_);
					result = _tmp11_;
					return result;
				}
			}
		}
	}
	result = NULL;
	return result;
}


static int _archive_read_support_format_all_boxes_libarchive_function (gpointer self) {
	int result;
	result = archive_read_support_format_all ((struct archive*) self);
	return result;
}


static int ___lambda87_ (BoxesArchiveReader* self) {
	int result = 0;
	struct archive* _tmp0_ = NULL;
	int* _tmp1_ = NULL;
	int _tmp2_ = 0;
	_tmp0_ = self->archive;
	_tmp1_ = self->priv->format;
	_tmp2_ = archive_read_set_format (_tmp0_, *_tmp1_);
	result = _tmp2_;
	return result;
}


static int ____lambda87__boxes_libarchive_function (gpointer self) {
	int result;
	result = ___lambda87_ ((BoxesArchiveReader*) self);
	return result;
}


static int _archive_read_support_filter_all_boxes_libarchive_function (gpointer self) {
	int result;
	result = archive_read_support_filter_all ((struct archive*) self);
	return result;
}


static Block11Data* block11_data_ref (Block11Data* _data11_) {
	g_atomic_int_inc (&_data11_->_ref_count_);
	return _data11_;
}


static void block11_data_unref (void * _userdata_) {
	Block11Data* _data11_;
	_data11_ = (Block11Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data11_->_ref_count_)) {
		BoxesArchiveReader* self;
		self = _data11_->self;
		_g_object_unref0 (self);
		g_slice_free (Block11Data, _data11_);
	}
}


static int _____lambda88_ (Block11Data* _data11_) {
	BoxesArchiveReader* self;
	int result = 0;
	struct archive* _tmp0_ = NULL;
	int _tmp1_ = 0;
	int _tmp2_ = 0;
	self = _data11_->self;
	_tmp0_ = self->archive;
	_tmp1_ = _data11_->filter;
	_tmp2_ = archive_read_append_filter (_tmp0_, _tmp1_);
	result = _tmp2_;
	return result;
}


static int ______lambda88__boxes_libarchive_function (gpointer self) {
	int result;
	result = _____lambda88_ (self);
	return result;
}


static int __lambda89_ (BoxesArchiveReader* self) {
	int result = 0;
	struct archive* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	int _tmp2_ = 0;
	_tmp0_ = self->archive;
	_tmp1_ = self->priv->filename;
	_tmp2_ = archive_read_open_filename (_tmp0_, _tmp1_, (gsize) BOXES_ARCHIVE_READER_BLOCK_SIZE);
	result = _tmp2_;
	return result;
}


static int ___lambda89__boxes_libarchive_function (gpointer self) {
	int result;
	result = __lambda89_ ((BoxesArchiveReader*) self);
	return result;
}


static void boxes_archive_reader_open_archive (BoxesArchiveReader* self, GError** error) {
	struct archive* _tmp0_ = NULL;
	int* _tmp1_ = NULL;
	GList* _tmp5_ = NULL;
	struct archive* _tmp10_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = archive_read_new ();
	_archive_read_finish0 (self->archive);
	self->archive = _tmp0_;
	_tmp1_ = self->priv->format;
	if (_tmp1_ == NULL) {
		struct archive* _tmp2_ = NULL;
		struct archive* _tmp3_ = NULL;
		_tmp2_ = self->archive;
		_tmp3_ = self->archive;
		boxes_execute_libarchive_function (_tmp2_, _archive_read_support_format_all_boxes_libarchive_function, _tmp3_, (guint) 1, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_IO_ERROR) {
				g_propagate_error (error, _inner_error_);
				return;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		}
	} else {
		struct archive* _tmp4_ = NULL;
		_tmp4_ = self->archive;
		boxes_execute_libarchive_function (_tmp4_, ____lambda87__boxes_libarchive_function, self, (guint) 1, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_IO_ERROR) {
				g_propagate_error (error, _inner_error_);
				return;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		}
	}
	_tmp5_ = self->priv->filters;
	if (_tmp5_ == NULL) {
		struct archive* _tmp6_ = NULL;
		struct archive* _tmp7_ = NULL;
		_tmp6_ = self->archive;
		_tmp7_ = self->archive;
		boxes_execute_libarchive_function (_tmp6_, _archive_read_support_filter_all_boxes_libarchive_function, _tmp7_, (guint) 1, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_IO_ERROR) {
				g_propagate_error (error, _inner_error_);
				return;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		}
	} else {
		GList* _tmp8_ = NULL;
		_tmp8_ = self->priv->filters;
		{
			GList* filter_collection = NULL;
			GList* filter_it = NULL;
			filter_collection = _tmp8_;
			for (filter_it = filter_collection; filter_it != NULL; filter_it = filter_it->next) {
				int filter = 0;
				filter = (int) ((gintptr) filter_it->data);
				{
					Block11Data* _data11_;
					struct archive* _tmp9_ = NULL;
					_data11_ = g_slice_new0 (Block11Data);
					_data11_->_ref_count_ = 1;
					_data11_->self = g_object_ref (self);
					_data11_->filter = filter;
					_tmp9_ = self->archive;
					boxes_execute_libarchive_function (_tmp9_, ______lambda88__boxes_libarchive_function, _data11_, (guint) 1, &_inner_error_);
					if (G_UNLIKELY (_inner_error_ != NULL)) {
						if (_inner_error_->domain == G_IO_ERROR) {
							g_propagate_error (error, _inner_error_);
							block11_data_unref (_data11_);
							_data11_ = NULL;
							return;
						} else {
							block11_data_unref (_data11_);
							_data11_ = NULL;
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
							g_clear_error (&_inner_error_);
							return;
						}
					}
					block11_data_unref (_data11_);
					_data11_ = NULL;
				}
			}
		}
	}
	_tmp10_ = self->archive;
	boxes_execute_libarchive_function (_tmp10_, ___lambda89__boxes_libarchive_function, self, (guint) 1, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == G_IO_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


static void boxes_archive_reader_class_init (BoxesArchiveReaderClass * klass) {
	boxes_archive_reader_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (BoxesArchiveReaderPrivate));
	G_OBJECT_CLASS (klass)->finalize = boxes_archive_reader_finalize;
}


static void boxes_archive_reader_instance_init (BoxesArchiveReader * self) {
	self->priv = BOXES_ARCHIVE_READER_GET_PRIVATE (self);
}


static void boxes_archive_reader_finalize (GObject* obj) {
	BoxesArchiveReader * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BOXES_TYPE_ARCHIVE_READER, BoxesArchiveReader);
	_archive_read_finish0 (self->archive);
	_g_free0 (self->priv->filename);
	_g_free0 (self->priv->format);
	_g_list_free0 (self->priv->filters);
	G_OBJECT_CLASS (boxes_archive_reader_parent_class)->finalize (obj);
}


GType boxes_archive_reader_get_type (void) {
	static volatile gsize boxes_archive_reader_type_id__volatile = 0;
	if (g_once_init_enter (&boxes_archive_reader_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (BoxesArchiveReaderClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) boxes_archive_reader_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BoxesArchiveReader), 0, (GInstanceInitFunc) boxes_archive_reader_instance_init, NULL };
		GType boxes_archive_reader_type_id;
		boxes_archive_reader_type_id = g_type_register_static (G_TYPE_OBJECT, "BoxesArchiveReader", &g_define_type_info, 0);
		g_once_init_leave (&boxes_archive_reader_type_id__volatile, boxes_archive_reader_type_id);
	}
	return boxes_archive_reader_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



